// Dlg_Common.h
// Neuron Computing Inc.
#ifndef __DlgCommon_h__
#define __DlgCommon_h__

#include "Widgets.h"

/////////////////////////////////////////////////////////////
// Dlg_Base
class Dlg_Base
{
public:
	Widget m_parent;
	Bool m_done;
	Widget m_shell;
	Widget m_form;
	int m_result;

	enum {
		IDOK,
		IDCANCEL,
	};
	// ActionListener
	class XActionListener : public ActionListener {
		public: void actionPerformed(int id)
			{Dlg_Base* pThis = THIS(Dlg_Base, m_actionListener);
			pThis->action(id);}
	} m_actionListener;
public:
	Dlg_Base();

	Bool createForm();
	void createOkCancel(int x, int y);
	void destroyForm();

	void doModal();
	void endDialog(int id);

	virtual void action(int id);
};

/////////////////////////////////////////////////////////////
// Dlg_Info
class Dlg_Info : public Dlg_Base
{
public:
    void show_info(char *);
};

/////////////////////////////////////////////////////////////
// Dlg_Edit
class Dlg_Edit : public Dlg_Base
{
public:
	Widget m_textField;
	char m_buffer[256];
public:
    void do_edit(char *, char *);

	void action(int id);
};

/////////////////////////////////////////////////////////////
// Dlg_List
class Dlg_List : public Dlg_Base
{
public:
	int m_curSel;
public:
	Dlg_List();
    int choose_one_from_list(char *prompt, char **list_items,
                             int number_of_items);

	void action(int id);
	virtual void itemSelected(int index);
};

/////////////////////////////////////////////////////////////
// Dlg_ChooseFont
class Dlg_ChooseFont : public Dlg_Base
{
public:
    int choose_font();
};

/////////////////////////////////////////////////////////////
// Dlg_File
class Dlg_File : public Dlg_Base
{
public:
    int choose_file_to_read(char* prompt, char* extension, char* file_name);
    int choose_file_to_write(char* prompt, char* file_name);
};

#endif
