// Widgets.cpp
// Neuron Computing Inc.
#include "Widgets.h"

void Label::create(Widget parent)
{
	m_w = XtCreateManagedWidget("", LABEL, parent, NULL, 0);
}

void Label::setTitle(char* title)
{
	Arg arg;
	XtSetArg(arg, XtNlabel, &title);
	XtSetValues(m_w, &arg, 1);
}

// PushButton
PushButton::PushButton()
{
	m_id = -1;
	m_l = NULL;
}

static void pushbutton_action(Widget w, PushButton* b, XtPointer client_data)
{
	if (b->m_l != NULL)
		b->m_l->actionPerformed(b->m_id);
}

void PushButton::create(Widget parent)
{
	m_w = XtCreateManagedWidget("", COMMAND, parent, NULL, 0);
#ifndef MOTIF
	XtAddCallback(m_w, XtNcallback,
					(XtCallbackProc)pushbutton_action, (XtPointer)this);
#else
	XtAddCallback(m_w, XmNactivateCallback,
					(XtCallbackProc)pushbutton_action, (XtPointer)this);
#endif
}

void PushButton::setTitle(char* title)
{
	Arg arg;
	XtSetArg(arg, XtNlabel, title);
	XtSetValues(m_w, &arg, 1);
}

void PushButton::addActionListener(ActionListener* l)
{
	m_l = l;
}

// TextField
void TextField::create(Widget parent)
{
}
